<button (click)="back()" class="button is-back-button"><img class="has-right-margin" src="assets/images/back.png">Retour</button>
<div *ngIf="loading" id="cont" class="container">
	<div class="yellow dot"></div>
	<div class="red dot"></div>
	<div class="blue dot"></div>
	<div class="violet dot"></div>
</div>
<div class="is-flex is-justify-center has-margin-top-5">
  <div *ngIf="error$ | async" class="notification is-danger is-flex is-align-center">
    <button class="delete" (click)="fail()"></button>
    <img src="assets/images/ex.png"/>
    <p class="has-margin-left-2">Chargement des objets impossible pour le moment.</p>
    <button class="button error-button has-margin-left-1" (click)="getObjects()">Relancer</button>
  </div>
</div>
<div *ngIf="canDisplay$ | async" [className]="globals.isMobile ? 'is-flex is-column' : 'is-flex has-left-margin has-items-center space-around'">
    <div  [className]="globals.isMobile ? 'is-flex is-column' : 'is-flex is-column is-large'">
        <form class="is-flex is-form" [formGroup]="createForm" >
            <div class="is-flex is-column has-right-margin">
                <div class="is-flex is-centered">
                    <label>Matière : <span>*</span></label>
                    <select (ngModelChange)="changeList()" [className]="globals.isMobile ? 'has-margin-bottom-2 has-margin-top-2' : 'has-margin-bottom-2 has-margin-top-2 fixed-size'" formControlName="module">
                        <option disabled [ngValue]="null">-- Pas choisi --</option>
                        <option *ngFor="let module of modules" [ngValue]="module.value">{{module.text}}</option>
                    </select>
                </div>
                <div class="is-flex is-centered">
                    <label>Type : <span>*</span></label>
                    <select [className]="globals.isMobile ? 'has-margin-bottom-2 has-margin-top-2' : 'has-margin-bottom-2 has-margin-top-2 fixed-size'" formControlName="type">
                        <option disabled [ngValue]="null">-- Pas choisi --</option>
                        <option *ngFor="let type of listTypes" [ngValue]="type.uuid">{{type.type}}</option>
                    </select>
                </div>
                <div class="is-flex is-centered">
                    <label for="timeExpected">Temps requis (min : sec) :</label>
                    <select class="time-select" formControlName="expectedTimeMinutes">
                        <option class="text-center" *ngFor="let minute of minutes" [ngValue]="minute">
                            {{minute}}
                        </option>
                    </select>
                    <select class="time-select has-left-margin" formControlName="expectedTimeSeconds">
                        <option class="text-center" *ngFor="let second of seconds" [ngValue]="second">
                            {{second}}
                        </option>
                    </select>
                </div>
            </div>
            
            <nav class="panel has-width">
                <p class="panel-heading">
                    Liste des questions<span>*</span>
                </p>
                <div class="is-flex flex-column panel-block">
                    <p class="control is-flex has-items-center">
                        <input id="search" #Search (input)="refresh()" class="input" type="search" placeholder="Rechercher">
                    </p>
                </div>
                <div class="has-overflow">
                    <div *ngFor="let elt of listQuestionsDisplayed; let i = index" [style.backgroundColor]="elt.background" [style.color]="elt.text" (click)="chooseQuestion(i)" class="panel-block has-items-center space-around">
                        <p class="is-name">{{elt.name}}</p>
                        <img [src]="elt.img" (click)="openModal(elt)"/>
                    </div>
                </div>
            </nav>
            <div *ngIf="!globals.isMobile" class="is-flex is-centered has-left-margin">
                <button #SubmitButton *ngIf="createForm.valid" class="button default-style is-black-button" (click)="createRoom()">Valider</button>
                <div *ngIf="failure$ | async" class="notification is-danger has-left-margin is-flex is-centered">
                    <button class="delete" (click)="delete()"></button>
                    <img src="assets/images/ex.png"/>
                    <p class="has-left-margin">{{textError}}</p>
                </div>
            </div>
        </form>
    </div>
    <div [className]="globals.isMobile ? 'is-flex is-column is-align-center has-margin-top-2' : 'is-flex is-column is-large has-margin-right-1'">
        <div class="is-flex is-centered">
            <h2 class="is-text">Ajouter un Objet</h2>
        </div>
        <form [className]="globals.isMobile ? 'is-flex is-formStyle is-column has-width is-centered' : 'is-flex is-centered is-between is-column is-formStyle'" [formGroup]="objectForm" (ngSubmit)="addObject()">
            <button [className]="objectForm.valid ? 'self buttonAdd' : 'self buttonAdd button-disabled'" type="submit"><img [className]="globals.isMobile ? 'is-icon' : ''" src="assets/images/plus.png"/></button>
            <div class="is-flex is-centered">
                <label class="is-label">Objet : <span>*</span></label>
                <select [className]="globals.isMobile ? 'has-margin-bottom-2 has-margin-top-2' : 'has-margin-bottom-2 has-margin-top-2 fixed-size'" formControlName="uuid">
                    <option disabled [ngValue]="null">-- Pas choisi --</option>
                    <option *ngFor="let type of listTypeObjects" [ngValue]="type.uuid">{{type.name}}</option>
                </select>
            </div>
            <div class="is-flex has-margin-top-2">
                <div class="is-flex is-column has-margin-right-2">
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="posX">Position X : <span>*</span></label>
                        <input id="posX" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="posX">
                    </div>
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="posY">Position Y : <span>*</span></label>
                        <input id="posY" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="posY">
                    </div>
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="posZ">Position Z : <span>*</span></label>
                        <input id="posZ" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="posZ">
                    </div>
                </div>
                <div class="is-flex is-column has-margin-left-2">
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="rotX">Rotation X : <span>*</span></label>
                        <input id="rotX" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="rotX">
                    </div>
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="rotY">Rotation Y : <span>*</span></label>
                        <input id="rotY" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="rotY">
                    </div>
                    <div class="is-flex has-margin-bottom-1">
                        <label class="is-label" for="rotZ">Rotation Z : <span>*</span></label>
                        <input id="rotZ" type="number" [className]="globals.isMobile ? 'is-mobile' : 'is-desktop'" formControlName="rotZ">
                    </div>
                </div>
            </div>
        </form>
        <nav class="panel has-width is-centered">
            <p class="panel-heading">
                Liste des objets<span>*</span>
            </p>
            <div class="is-flex flex-column panel-block">
                <p class="control is-flex has-items-center">
                    <input id="search" #Search2 (input)="refreshObj()" class="input" type="search" placeholder="Rechercher">
                </p>
            </div>
            <div class="has-overflow">
                <div *ngFor="let elt of listObjectsDisplayed; let i = index" [style.backgroundColor]="elt.background" [style.color]="elt.text" class="panel-block has-items-center space-around">
                    <p class="is-name" [innerHTML]="getElt(elt)"></p>
                    <button class="buttonAdd" (click)="openModifyObject(elt, i)"><img [className]="globals.isMobile ? 'is-icon' : 'is-icon-desktop'" src="assets/images/update.png"/></button>
                    <button class="buttonAdd" (click)="askDelete(i)"><img [className]="globals.isMobile ? 'is-icon' : ''" src="assets/images/cross.png"/></button>
                </div>
            </div>
        </nav>
        <div *ngIf="globals.isMobile" class="is-flex is-centered has-left-margin">
            <button #SubmitButton *ngIf="createForm.valid" class="button default-style is-black-button" (click)="createRoom()">Valider</button>
            <div *ngIf="failure$ | async" class="notification is-danger has-left-margin is-flex is-centered">
                <button class="delete" (click)="delete()"></button>
                <img src="assets/images/ex.png"/>
                <p class="has-left-margin">{{textError}}</p>
            </div>
        </div>
    </div>
</div>
<div #Question class="modal">
    <div class="modal-background"></div>
    <div class="modal-card">
        <header class="modal-card-head is-flex is-between">
            <h1 class="is-styled">
                Information sur : <span class="is-bold">{{text}}</span>
            </h1>
            <button class="delete" (click)="close('question')" aria-label="close"></button>
        </header>
        <section class="modal-card-body is-flex is-column">
           
            <div class="is-flex is-column">
                <div class="is-flex is-column">
                    <label class="is-label">Question : </label>
                    <p class="is-p">
                        {{question.question}}
                    </p>
                </div>
                <div class="is-flex is-column has-margin-top-1">
                    <label class="is-label">Explication : </label>
                    <p class="is-p">
                        {{question.explication}}
                    </p>
                </div>
                <div class="is-flex has-margin-top-1">
                    <label class="is-label">Niveau : </label>
                    <p class="is-p">{{question.level}}</p>
                
                </div>
                <div class="is-flex has-margin-top-1">
                    <label class="is-label">Difficulté : </label>
                    <p class="is-p">{{question.difficulty}}</p>
                </div>
            </div>
        </section>
    </div>
</div>

<div #Object class="modal">
    <div class="modal-background"></div>
    <div class="modal-card">
        <header class="modal-card-head is-flex is-between">
            <h1 class="is-styled">
                Modification de l'objet
            </h1>
            <button class="delete" (click)="close('object')" aria-label="close"></button>
        </header>
        <section class="modal-card-body is-flex is-column">
            <form class="is-flex is-centered is-between is-column" [formGroup]="modForm" (ngSubmit)="modify()">
                <div class="is-flex is-centered">
                    <label class="is-label">Objet : </label>
                    <select [className]="globals.isMobile ? 'has-margin-bottom-2 has-margin-top-2' : 'has-margin-bottom-2 has-margin-top-2 fixed-size'" formControlName="uuid">
                        <option disabled [ngValue]="null">-- Pas choisi --</option>
                        <option *ngFor="let type of listTypeObjects" [ngValue]="type.uuid">{{type.name}}</option>
                    </select>
                </div>
                <div class="is-flex has-margin-top-2">
                    <div class="is-flex is-column has-margin-right-2">
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label" >Position X : </label>
                            <input type="number" formControlName="posX">
                        </div>
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label">Position Y : </label>
                            <input type="number" formControlName="posY">
                        </div>
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label">Position Z : </label>
                            <input type="number" formControlName="posZ">
                        </div>
                    </div>
                    <div class="is-flex is-column has-margin-left-2">
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label">Rotation X : </label>
                            <input type="number" formControlName="rotX">
                        </div>
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label" >Rotation Y : </label>
                            <input type="number" formControlName="rotY">
                        </div>
                        <div class="is-flex has-margin-bottom-1">
                            <label class="is-label">Rotation Z : </label>
                            <input type="number" formControlName="rotZ">
                        </div>
                    </div>
                </div>
                <div class="is-flex is-centered">
                    <button class="button default-style is-black-button" type="submit">Valider</button>
                </div>
            </form>
        </section>
    </div>
</div>
<div #Delete class="modal">
    <div class="modal-background"></div>
    <div class="modal-card">
      <section class="modal-card-body is-flex is-column">
        <button class="delete self" (click)="close('delete')" aria-label="close"></button>
        <div class="is-flex is-space-around has-margin-top-2">
          <button class="button is-success has-margin-right-4" (click)="deleteObject()">Confirmer</button>
          <button class="button is-danger" (click)="cancel()">Annuler</button>
        </div>
      </section>
    </div>
</div>